% Erzeugung von Pseudo-Daten eines lognormalverteilten Zufallsfelds
clear all; close all;  clc;

%{
--------------------------------------------------------------------------
Created by:                         Date:           Comment:
Sebastian Geyer                     Juli 2021         ---
Technische Universitaet Muenchen
s.geyer@tum.de
--------------------------------------------------------------------------
%}

% Parameter
mu    = 15;  % Mittelwert
si    = 8;   % Standardabweichung
g_mic = 0.25; % Anteil der Mikrokorrelation
nu    = 2.5; % Smoothness-Parameter
lc    = 5;   % Korrelationslnge

% Parameter der zugrundeliegenden Normalverteilung
muln = log(mu.^2./sqrt(si^2+mu.^2));
siln = sqrt(log(si^2./mu.^2+1));

% Korrelationsfunktion
R_fun_meso = Matern_corr(nu);
R_fun      = @(D)g_mic*(D==0)+(1-g_mic)*R_fun_meso(D,lc);

% Messpositionen
x  = [3 7 9 15 16 21 24 25 28 33];
Dx = pdist2(x',x');

% Erzeugung von Zufallsdaten
R = R_fun(Dx);
y = round(exp(mvnrnd(muln*ones(1,10),siln^2*R,1)),1);

% Abspeichern der Daten
M = [(1:length(x));y;x]';
writematrix(M,'Daten_dummy.xlsx','Range','A2')