% Erzeugung von Pseudo-Daten eines lognormalverteilten Zufallsfelds
clear all; close all;  clc;

%{
--------------------------------------------------------------------------
Created by:                         Date:           Comment:
Sebastian Geyer                     Juli 2021         ---
Technische Universitaet Muenchen
s.geyer@tum.de
--------------------------------------------------------------------------
%}

% Parameter
mu    = 15;  % Mittelwert
si    = 8;   % Standardabweichung
g_mic = 0.25; % Anteil der Mikrokorrelation
nu    = 2.5; % Smoothness-Parameter
L_c   = [5 5 1];   % Korrelationslnge

% Parameter der zugrundeliegenden Normalverteilung
muln = log(mu.^2./sqrt(si^2+mu.^2));
siln = sqrt(log(si^2./mu.^2+1));

% Korrelationsfunktion
R_fun_meso = Matern_corr(nu);
R_fun      = @(Dw)g_mic*(Dw==0)+(1-g_mic)*R_fun_meso(Dw);

% Messpositionen
x  = [25 25 25 25 25 25 50 50 50 50 50 50; 2 2 2 2 2 2 1.75 1.75 1.75 1.75 1.75 1.75;0.5 2 3.2 5 7 8.5 0.7 1.4 1.9 2.8 5.2 7.5]';

% Erzeugung von Zufallsdaten
D_mm = zeros(size(x,1),size(x,1),size(x,2));
for ii = 1:size(x,2)
    D_mm(:,:,ii) = pdist2(x(:,ii),x(:,ii));
end
Dwmm = sqrt(sum((D_mm./permute(L_c,[1 3 2])).^2,3));
R = R_fun(Dwmm);
y = round(exp(mvnrnd(muln*ones(1,size(x,1)),siln^2*R,1)),1);

% Abspeichern der Daten
M = [(1:length(x));y;x']';
writematrix(M,'Daten_dummy.xlsx','Range','A2')